import processing.serial.*;

Serial myPort;
PFont font;

int SensorCount = 12;
int[] data = new int[12];

// sensors[2], sensors[3], sensors[4], sensors[0], sensors[1], accelX, accelY, accelZ, joyX, joyY, butC, butZ);
// raw data for accelemoter, accl + joy,           normalized data, buttons status

String[] datastr = {"rAX", "rAY", "rAZ", "rJX", "rJY", "nAX", "nAY", "nAZ", "nJX", "nJY", "C", "Z"};


int[] datamin = new int[12];
int[] datamax = new int[12];

int[][] confvalues =
{  /*min, max, fill colour */
  {300, 700, #FF0000}, /* rAX */
  {300, 700, #00FF00}, /* rAY */  
  {300, 700, #0000FF}, /* rAZ */    

  { 24, 227, #668014}, /* rJX */    
  { 24, 227, #FFE303}, /* rJY */

  {-90,  90, #FF0000}, /* nAX */
  {-90,  90, #00FF00}, /* nAY */  
  {-90,  90, #0000FF}, /* nAZ */    

  {-127, 127, #668014}, /* nJX */    
  {-127, 127, #FFE303}, /* nJY */
};

int maxH1 = 200;
int maxH2 = 100;
int yoff1 = 100;
int yoff2 = 200;
int toff =  100;

int offsetx;

void setup() {
  size(550, 400);
  smooth(); 
  background(255);
  font = loadFont("ArialMT-10.vlw"); 
  textFont(font); 

  myPort = new Serial(this, Serial.list()[0], 38400);
  myPort.bufferUntil('\n');
  
  for (int i=0; i<10; i++)
  {
    datamax[i] =  confvalues[i][0];
    datamin[i] =  confvalues[i][1];
  }  
}

void draw()
{
  if (data.length == SensorCount)
  {
    for (int i=0; i < data.length; i++)
    {
      if (data[i] > datamax[i]) datamax[i] = data[i];
      if (data[i] < datamin[i]) datamin[i] = data[i];
    }

    fill(255);
    stroke(255);
    rect(0, 0, width, height);

    fill(0);
    stroke(0);

    text("Data:", 5, height-toff+45);
    text("max :", 5, height-toff+30);      
    text("min :", 5, height-toff+15);
 
    offsetx =40;    
    for (int i=0; i < data.length; i++)
    { 
      text(datastr[i], offsetx, height-toff+60);
      offsetx += 40;
    }    
    
    offsetx =40;
    for (int i=0; i < 10; i++)
    { 
      text(data[i],    offsetx, height-toff+45);
      text(datamax[i], offsetx, height-toff+30);      
      text(datamin[i], offsetx, height-toff+15);      
      offsetx += 40;
    }

    offsetx =40;
    for (int i=0; i < 5; i++)
    {
      fill(confvalues[i][2]);
      rect(offsetx+2, height-yoff1-(data[i]*maxH1)/confvalues[i][1],    22, (data[i]*maxH1)/confvalues[i][1]);
      line(offsetx, height-yoff1-(datamin[i]*maxH1)/confvalues[i][1], offsetx+26,  height-yoff1-(datamin[i]*maxH1)/confvalues[i][1]);
      line(offsetx, height-yoff1-(datamax[i]*maxH1)/confvalues[i][1], offsetx+26,  height-yoff1-(datamax[i]*maxH1)/confvalues[i][1]);
      offsetx += 40;      
    }

    offsetx =40*6;
    for (int i=5; i < 10; i++)
    {
      fill(confvalues[i][2]);
      rect(offsetx+2, height-yoff2-(data[i]*maxH2)/confvalues[i][1],    22, (data[i]*maxH2)/confvalues[i][1]);
      line(offsetx, height-yoff2-(datamin[i]*maxH2)/confvalues[i][1], offsetx+26,  height-yoff2-(datamin[i]*maxH2)/confvalues[i][1]);
      line(offsetx, height-yoff2-(datamax[i]*maxH2)/confvalues[i][1], offsetx+26,  height-yoff2-(datamax[i]*maxH2)/confvalues[i][1]);
      offsetx += 40;      
    }
    
    fill(0);
    stroke(0);
    offsetx =40*11;
    for (int i=10; i < 12; i++)
    {
      fill(0);
      text(data[i],    offsetx, height-toff+45);
      fill(#00FF00*data[i]);
      ellipse(offsetx+15, height-yoff2, 15,15);
      offsetx += 40;      
    }   
   
  }
}

void serialEvent(Serial myPort) { 
  // get the ASCII string:
  String inString = myPort.readStringUntil('\n');

  if (trim(inString) != null) {
    // trim off any whitespace:
    inString = trim(inString);
    // split the string on the commas and convert the 
    // resulting substrings into an integer array:
    data = int(split(inString, ","));
  }
}

