/*
 * testing Ping-Pong Board from FRANZIS / conrad.de
 *
 *
 * Ver.     Date         Author           Comments
 * -------  ----------   --------------   ------------------------------
 * 1.00	    07.02.2010   Piotr Platek     initial
 *
 *
 * Feel free to provide me any feedback 
 ***************************************************************************
 **
 **  This program is free software; you can redistribute it and/or
 **  modify it under the terms of the GNU General Public License
 **  as published by the Free Software Foundation; either version 2
 **  of the License, or (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software Foundation, 
 **  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ***************************************************************************
 */


#include "main.h"

uint8_t buffor[50] = "";	// buffor for text display & manipulation

int main(void)
{
  cli();

#ifdef DEBUGON
	USART_Init();
#endif

  DDRC = 0xFF;   // port B, C, D as Output
  DDRB = 0xFF;   // TWI/C2I will be set by nunchuckInit/TWI funnctions
  DDRD = 0xFF;

	/* initialize timers */
  TCCR0 |= _BV(CS01) | _BV(CS00); // clk prescale (clk/64)
  TIMSK |= _BV(TOIE0); 			// enable timer/counter0 overflow interrupt 
  TCNT0 = 0;           			// reset the timer

  sei();


  nunchuckInit(); 				// initialize nunchuck
  _delay_ms(100); 				// wait a bit for nunchuck gets ready

  nunchuckRead(); 				// read the data from nunchuck
  srandom((accelX*accelY)/accelZ);// in order to start/seed the random generator

  while(1)
  {
	nunchuckRead(); // read data from nunchuck
		sprintf((char*)buffor, "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\n\r",
		sensors[2], sensors[3], sensors[4], sensors[0], sensors[1], accelX, accelY, accelZ, joyX, joyY, butC, butZ);
		rsprint((int8_t *)buffor);

	gLEDs[0]=accelX;
	gLEDs[1]=accelY;
	gLEDs[2]=accelZ;
	gLEDs[3]=joyX;
	gLEDs[4]=joyY;


	if (!butZ) 			// if Z pressed move to the initial position
	{
		LedCLS();
	}
	_delay_ms(150);				// wait a bit 

	// the time for one level has passed
  }
	return 0;
}
